<template>
  <div class="fr-container fr-p-5w">
    <TheHeader title="Modifier ma structure" />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomAlert
            v-if="fetchError"
            :alert-type="AlertType.Error"
            :message="fetchError"
          />

          <AtomLoader
            v-if="organisationPending || followUpTypesPending"
            class="fr-mx-auto"
          />
          <OrganisationForm
            v-else-if="organisation && followUpTypes"
            :organisation="organisation"
            :follow-up-types="followUpTypes"
            :is-submitting="isSubmitting"
            @update-organisation="onUpdateOrganisation"
          />

          <HistoryItem
            :id="organisationId"
            class="fr-mt-4w"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { useAuthStore } from '~/store/auth'
  import { AlertType } from '~/utils/constants/alert'
  import { getRandomId } from '~~/utils/random'

  definePageMeta({ middleware: 'can-edit-organisation' })

  const { $getItem, $getItems, $updateItem, $snackbar } = useNuxtApp()
  const authStore = useAuthStore()

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const {
    data: organisation,
    pending: organisationPending,
    error: organisationError
  } = useLazyAsyncData(getRandomId('organisation'), loadOrganisation, {
    server: false
  })

  const {
    data: followUpTypes,
    pending: followUpTypesPending,
    error: followUpTypesError
  } = useLazyAsyncData(getRandomId('followUpTypes'), loadFollowUpTypes, {
    server: false
  })

  const organisationId = computed(() => authStore.userOrganisationId)

  const fetchError = computed(() => {
    if (organisationError.value) {
      return "Les informations de votre structure n'ont pas pu être chargées."
    }
    if (followUpTypesError.value) {
      return "Les types d'accompagnement n'ont pas pu être chargés."
    }
    return ''
  })

  async function loadOrganisation() {
    const fields = [
      '*',
      'follow_up_types.id',
      'follow_up_types.follow_up_types_id'
    ]
    const res = await $getItem('organisation', organisationId.value, {
      fields
    })

    if (res.status === 200) return res.data.data
    throw new Error(res.data.errors[0].message)
  }

  async function loadFollowUpTypes() {
    const res = await $getItems('follow_up_types', {
      fields: [
        'id',
        'name',
        'type',
        'count(follow_ups)',
        'count(help_requests)'
      ],
      sort: [{ field: 'name', sort: '' }]
    })

    if (res.status === 200) {
      return res.data.data
    }
    throw new Error(res.data.errors[0].message)
  }

  async function onUpdateOrganisation(updatedOrganisation) {
    isSubmitting.value = true
    try {
      const res = await $updateItem(
        `organisation`,
        organisation.value,
        updatedOrganisation,
        {
          fields: [
            '*',
            'follow_up_types.id',
            'follow_up_types.follow_up_types_id'
          ]
        }
      )

      if (res.status === 200) {
        if (res.data?.data) {
          organisation.value = res.data.data
          $snackbar.success(
            'Les informations de votre structure ont été mises à jour.'
          )
        }
      } else throw new Error(res.data.errors[0].message)
    } catch {
      $snackbar.error('La mise à jour de votre structure a échoué.', () =>
        formContainer.value?.querySelector('select')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
